<?php

namespace Modules\St\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class ApprovalRule extends Model
{
    use HasFactory,LogsActivity;

    protected $fillable = [];
    protected $table = 'st_approval_rules';
    protected static $logAttributes = [
        'id',
        'description',
        'message',
        'is_designation',
        'prioraty',
        'user_id',
        'designation_id',
        'slug_id',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "st_approval_rules";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
    /*protected static function newFactory()
    {
        return \Modules\St\Database\factories\ApprovalRuleFactory::new();
    }*/
}
