<?php

namespace Modules\St\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class Currency extends Model
{
    use HasFactory,LogsActivity;
    protected $table = 'st_currencies';
    protected $primaryKey = 'currency_id';
    protected $fillable = [];
    protected static $logAttributes = [
        'currency_id',
        'currency',
        'iso_code',
        'symbol',
        'status',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "st_currencies";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }

}
