<?php

namespace Modules\St\Http\Controllers;

use App\Models\Notification;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Hr\Entities\Bank;
use Modules\Hr\Entities\BankBranch;
use Modules\Hr\Entities\Company;
use Modules\Hr\Entities\Employee;
use Modules\Hr\Entities\EmployeeCategory;
use Modules\Hr\Entities\EmployeeCivilstatus;
use Modules\Hr\Entities\EmployeeDepartment;
use Modules\Hr\Entities\EmployeeDesignation;
use Modules\Hr\Entities\EmployeeSection;
use Modules\Hr\Entities\EmployeeSite;
use Modules\Hr\Entities\EmployeeStatus;
use Modules\Hr\Entities\EmployeeSubsection;
use Modules\Hr\Entities\EmployeeType;
use Modules\Hr\Entities\GsDivision;
use Modules\Hr\Entities\MohDivision;
use Modules\Hr\Entities\Police;
use Modules\Hr\Entities\Town;
use Modules\St\Entities\ApprovalRollback;
use Modules\St\Entities\ApprovalRule;
use Modules\St\Entities\ApprovalTask;
use Modules\St\Entities\Module;
use Modules\St\Entities\Permission;

class ApprovalController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        return view('st::index');
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('st::create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        return view('st::show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        return view('st::edit');
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        //
    }





    public function allModules()
    {
        try {
            $modules =  Module::all();
            $responseBody = $this->responseBody(true, "Module", "allModules", $modules);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Module", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function allApproval($module_id)
    {
        try {
            $query = "SELECT
           permissions.`id` AS id,
           permissions.`name` AS name,
           permissions.`slug` AS slug,
           permissions.`sub` AS sub,
           module_permissions.`module_id` AS module_id,
           module_permissions.`permission_id` AS permission_id
      FROM
           `permissions` permissions INNER JOIN `module_permissions` module_permissions ON permissions.`id` = module_permissions.`permission_id` WHERE module_permissions.module_id = '" . $module_id . "' AND permissions.sub = 'null'";

            $permissions = DB::select($query);
            foreach ($permissions as $permission) {

                $query_count = "SELECT COUNT(*) AS count FROM `permissions` WHERE sub = '" . $permission->permission_id . "'";
                $count = DB::select($query_count)[0];
                if ($count) {
                    $permission->sub_count = $count->count;
                }
                $permission->is_approval = $this->isApproval($permission->id);
            }


            $responseBody = $this->responseBody(true, "Approval", "allApproval", $permissions);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function allSubApproval($module_id, $permission_id)
    {
        try {
            $permissions = $this->subPermissions($module_id, $permission_id);
            foreach ($permissions as $permission) {

                $query_count = "SELECT COUNT(*) AS count FROM `permissions` WHERE sub = '" . $permission->permission_id . "'";
                $count = DB::select($query_count)[0];
                if ($count) {
                    $permission->sub_count = $count->count;
                }
                $permission->is_approval = $this->isApproval($permission->id);
            }


            $responseBody = $this->responseBody(true, "SubApproval", "allSubApproval", $permissions);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SubApproval", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    private function subPermissions($module_id, $permission_id)
    {

        $query = "SELECT
            permissions.`id` AS id,
            permissions.`name` AS name,
            permissions.`slug` AS slug,
            permissions.`sub` AS sub,
            permissions.`action` AS action,
            module_permissions.`module_id` AS module_id,
            module_permissions.`permission_id` AS permission_id
       FROM
            `permissions` permissions INNER JOIN `module_permissions` module_permissions ON permissions.`id` = module_permissions.`permission_id` WHERE module_permissions.module_id = '" . $module_id . "' AND permissions.sub = '" . $permission_id . "'";

        return  DB::select($query);
    }


    public function allDesignation()
    {
        try {
            $designation =  EmployeeDesignation::all();
            $responseBody = $this->responseBody(true, "Approval", "allDesignation", $designation);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    private function isApproval($id)
    {

        $slug = ApprovalRule::where('slug_id', '=', $id)->first();
        if ($slug) {
            return true;
        }
        return false;
    }


    /**
     * allEmployee
     * This function is used to get all employee's name for auto complete.
     */
    public function allEmployee()
    {

        try {
            $employees = Employee::all();

            $employee_arr = [];
            for ($i = 0; $i < count($employees); $i++) {
                array_push($employee_arr, ["img" => $employees[$i]['photo_parth'], "id" => $employees[$i]['employee_id'], "value" => $employees[$i]['name_withinitial']]);
            }
            $responseBody = $this->responseBody(true, "Approval", "employees", $employee_arr);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function saveApproval(Request $request)
    {
        try {
            $slug = $request->get('slug');
            $description = $request->get('description');
            $message = $request->get('message');
            $data = $request->get('data');

            foreach ($data as $d) {

                $designation_id = NULL;
                $user_id = NULL;
                $is_designation = false;
                if ($d['setting'] == 'designation') {
                    $designation_id = $d['id'];
                    $user_id = NULL;
                    $is_designation = true;
                }

                if ($d['setting'] == 'user') {
                    $user_id = $d['id'];
                    $designation_id = NULL;
                    $is_designation = false;
                }

                $prioraty = $d['priority'];

                if ($is_designation) {
                    $employees = Employee::where('designation_id', '=', $designation_id)->get();
                    foreach ($employees as $employee) {
                        $approval = new ApprovalRule();
                        $approval->description = $description;
                        $approval->message = $message;
                        $approval->is_designation = $is_designation;
                        $approval->prioraty = $prioraty;
                        $approval->user_id = $employee->employee_id;
                        $approval->designation_id = $designation_id;
                        $approval->slug_id = $slug;
                        $approval->save();
                    }
                } else {
                    $approval = new ApprovalRule();
                    $approval->description = $description;
                    $approval->message = $message;
                    $approval->is_designation = $is_designation;
                    $approval->prioraty = $prioraty;
                    $approval->user_id = $user_id;
                    $approval->designation_id = $designation_id;
                    $approval->slug_id = $slug;
                    $approval->save();
                }
            }

            $responseBody = $this->responseBody(true, "Approval", "saved", null);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function allUserApprovalList()
    {
        try {
            $user_id = Auth::user()->user_id;
            //$notification = Notification::where([['recipient_id', '=', $user_id], ['is_unread', '=', 0]])->get();
            $rollback = $this->getRollbacks($user_id);


            $responseBody = $this->responseBody(true, "Approval", "notification", $rollback);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    private function getRollbacks($user_id)
    {

        $query = 'SELECT
        st_approval_rollbacks.`rand_id` AS rollbacks_id,
        st_approval_rollbacks.`status` AS rollbacks_status,
        st_approval_tasks.`is_approval` AS is_approval,
        st_approval_rules.`prioraty` AS prioraty,
        st_approval_rules.`id` AS rule_id,
        st_approval_rules.`slug_id` AS slug_id,
        st_approval_rules.`description` AS description
   FROM
        `st_approval_rollbacks` st_approval_rollbacks INNER JOIN `st_approval_tasks` st_approval_tasks ON st_approval_rollbacks.`rand_id` = st_approval_tasks.`approval_rollback_id`
        INNER JOIN `st_approval_rules` st_approval_rules ON st_approval_tasks.`approval_rule_id` = st_approval_rules.`id` WHERE st_approval_rules.`user_id` = "' . $user_id . '" AND st_approval_rollbacks.`status` = 1 AND st_approval_tasks.`is_approval` = 0 GROUP BY st_approval_rollbacks.`rand_id`';

        $result =  DB::select($query);
        $rollback_array = array();
        foreach ($result as $rollback) {
            array_push($rollback_array, [
                'id' => $rollback->rollbacks_id,
                //'json' => json_decode($rollback->rollback_sql, true),
                'prioraty' => $rollback->prioraty,
                'description' => $rollback->description,
                'slug_id' => $rollback->slug_id,
                'rule_id' => $rollback->rule_id,
            ]);
        }
        return $rollback_array;
    }




    public function approvedAction($rollback_id, $slug_id, $rule_id)
    {
        try {
            $user_id = Auth::user()->user_id;
            $available_prioraty = $this->is_approvalPrioraty($rollback_id, $slug_id);
            $user_prioraty = $this->getUserPrioraty($slug_id, $user_id);


            $status = false;
            if ($available_prioraty == $user_prioraty) {
                $status = true;
                $this->commitAction($slug_id, $user_prioraty, $rollback_id);
            } else {
                $status = false;
            }

            $responseBody = $this->responseBody(true, "ApprovedAction", "Action", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "ApprovedAction", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function getUserPrioraty($slug, $user_id)
    {
        $rule = ApprovalRule::where([['slug_id', '=', $slug], ['user_id', '=', $user_id]])->first();
        return $rule->prioraty;
    }


    public function getApproval($slug_id)
    {
        try {
            $approvals = ApprovalRule::where('slug_id', '=', $slug_id)->get();
            foreach ($approvals as $approval) {
                $user_id =  $approval->user_id;
                if ($user_id != null) {
                    $approval->name = Employee::find($user_id)->name_withinitial;
                }

                $designation_id =  $approval->designation_id;
                if ($designation_id != null) {
                    $approval->designation = EmployeeDesignation::find($designation_id)->designation;
                }
            }

            $responseBody = $this->responseBody(true, "Approval", "Approval", $approvals);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function deleteApproval($approval_id)
    {
        try {
            $approval = ApprovalRule::find($approval_id);
            $delete = $approval->delete();
            if ($delete) {
                $responseBody = $this->responseBody(true, "Approval", "deleted", null);
            } else {
                $responseBody = $this->responseBody(false, "Approval", "saved", $delete);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function updateApproval(Request $request)
    {

        try {
            $slug = $request->get('slug');
            $description = $request->get('description');
            $message = $request->get('message');
            $data = $request->get('data');

            $approvals = ApprovalRule::where('slug_id', '=', $slug)->get();
            foreach ($approvals as $approval) {
                $approval->message = $message;
                $approval->description = $description;
                $approval->update();
            }

            foreach ($data as $d) {
                $user_id = $d['id'];
                $prioraty = $d['priority'];
                $approval = ApprovalRule::where([['user_id', '=', $user_id], ['slug_id', '=', $slug]])->first();
                if ($approval) {
                    $approval->prioraty = $prioraty;
                    $approval->update();
                }
            }



            $responseBody = $this->responseBody(true, "Approval", "updated", $data);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Approval", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function is_approvalPrioraty($rollback_id, $slug_id)
    {

        $query = "SELECT
        st_approval_tasks.`approval_rule_id` AS rule_id,
        st_approval_tasks.`approval_rollback_id` AS rollback_id,
        st_approval_rules.`prioraty` AS prioraty,
        st_approval_tasks.`id` AS tasks_id,
        st_approval_tasks.`is_approval` AS is_approval
        FROM
        `st_approval_rules` st_approval_rules INNER JOIN `st_approval_tasks` st_approval_tasks ON st_approval_rules.`id` = st_approval_tasks.`approval_rule_id`
        WHERE st_approval_tasks.`is_approval` = '0' AND st_approval_tasks.`approval_rollback_id` = '" . $rollback_id . "' AND st_approval_rules.`slug_id`='" . $slug_id . "' ORDER BY
        st_approval_rules.`prioraty` ASC";

        $result = DB::select($query);
        $avilable_prioraty = 0;
        foreach ($result as $approval) {
            if (!$approval->is_approval) {
                $avilable_prioraty = $approval->prioraty;
                break;
            }
        }

        return $avilable_prioraty;
    }


    public function getSlugName($slug_id)
    {

        $permission = Permission::find($slug_id);
        return $permission->slug;
    }



    public function userApproval($prioraty, $rollback_id)
    {

        $query = "SELECT
        st_approval_tasks.`id` AS tasks_id
        FROM
        `st_approval_rules` st_approval_rules INNER JOIN `st_approval_tasks` st_approval_tasks ON st_approval_rules.`id` = st_approval_tasks.`approval_rule_id`
        WHERE
        st_approval_tasks.`approval_rollback_id` = '" . $rollback_id . "'
        AND st_approval_rules.`prioraty` = '" . $prioraty . "'";

        $result = DB::select($query);
        foreach ($result as $approval) {
            $task =  ApprovalTask::find($approval->tasks_id);
            $task->is_approval = 1;
            $task->update();
        }
    }



    private function commitAction($slug_id, $prioraty, $rollback_id)
    {


        $slug = $this->getSlugName($slug_id);

        if ($slug == 'employee_create') {

            $this->userApproval($prioraty, $rollback_id);
            $can = $this->can($rollback_id, $slug_id);

            if ($can) {
                return $this->createEmployee($rollback_id);
            } else {
                return false;
            }
        } else  if ($slug == 'employee_edit') {

            $this->userApproval($prioraty, $rollback_id);
            $can = $this->can($rollback_id, $slug_id);

            if ($can) {
                return $this->editEmployee($rollback_id);
            } else {
                return false;
            }
        } else  if ($slug == 'employee_delete') {

            $this->userApproval($prioraty, $rollback_id);
            $can = $this->can($rollback_id, $slug_id);

            if ($can) {
                return $this->deleteEmployee($rollback_id);
            } else {
                return false;
            }
        }
    }



    private function can($rollback_id, $slug_id)
    {
        $query = "SELECT
        st_approval_rules.`prioraty` AS prioraty,
        st_approval_tasks.`is_approval` AS is_approval
        FROM
        `st_approval_rules` st_approval_rules INNER JOIN `st_approval_tasks` st_approval_tasks ON st_approval_rules.`id` = st_approval_tasks.`approval_rule_id`
        WHERE st_approval_tasks.`is_approval` = '0' AND st_approval_tasks.`approval_rollback_id` = '" . $rollback_id . "' AND st_approval_rules.`slug_id`='" . $slug_id . "' ORDER BY
        st_approval_rules.`prioraty` ASC";

        $result = DB::select($query);
        foreach ($result as $prioraty) {
            if (!$prioraty->is_approval) {
                return false;
            }
        }
        return true;
    }



    private function createEmployee($rollback_id)
    {
        $rollback = ApprovalRollback::where('rand_id', '=', $rollback_id)->get();
        //$json = json_decode($rollback->sql, true);
        $employee = new Employee();
        foreach ($rollback as $record) {
            $employee[$record->column_name] = $record->value;
        }
        $save = $employee->save();
        if ($save) {
            $query = "UPDATE st_approval_rollbacks SET status = '0' WHERE rand_id = '" . $rollback_id . "'";
            DB::select($query);
            //$rollback->status = 0;
            //$rollback->update();
        }
        return $save;
    }


    private function editEmployee($rollback_id)
    {
        $rollback = ApprovalRollback::find($rollback_id);
        $json = json_decode($rollback->sql, true);
        $employee = Employee::find($json['employee_id']);
        $employee->forceFill($json);
        $save = $employee->update();
        if ($save) {
            $rollback->status = 0;
            $rollback->update();
        }
        return $save;
    }


    private function deleteEmployee($rollback_id)
    {
        $rollback = ApprovalRollback::find($rollback_id);
        $json = json_decode($rollback->sql, true);
        $employee = Employee::find($json['employee_id']);
        $employee->forceFill($json);
        $save = $employee->delete();
        if ($save) {
            $rollback->status = 0;
            $rollback->update();
        }
        return $save;
    }





    public function employee($id)
    {
        try {
            $query = "SELECT * FROM st_approval_rollbacks WHERE st_approval_rollbacks.rand_id = '" . $id . "'";

            $result = DB::select($query);
            foreach ($result as $record) {


                if ($record->field_name == 'Town') {
                    $record->value = Town::find($record->value)->town;
                }

                if ($record->field_name == 'Gender') {
                    if ($record->value == 1) {
                        $record->value = 'Male';
                    } else {
                        $record->value = 'Female';
                    }
                }

                if ($record->field_name == 'CivilStatus') {
                    $record->value = EmployeeCivilstatus::find($record->value)->civilstatus;
                }

                if ($record->field_name == 'Designation') {
                    $record->value = EmployeeDesignation::find($record->value)->designation;
                }


                if ($record->field_name == 'Bank') {
                    $record->value = Bank::find($record->value)->bank;
                }

                if ($record->field_name == 'Bank Branch') {
                    $record->value = BankBranch::find($record->value)->bankbranch;
                }

                if ($record->field_name == 'Employee Type') {
                    $record->value = EmployeeType::find($record->value)->employeetype;
                }

                if ($record->field_name == 'Employee Status') {
                    $record->value = EmployeeStatus::find($record->value)->employeestatus;
                }

                if ($record->field_name == 'Category') {
                    $record->value = EmployeeCategory::find($record->value)->category;
                }

                if ($record->field_name == 'Site') {
                    $record->value = EmployeeSite::find($record->value)->site;
                }

                if ($record->field_name == 'Department') {
                    $record->value = EmployeeDepartment::find($record->value)->department;
                }

                if ($record->field_name == 'Section') {
                    $record->value = EmployeeSection::find($record->value)->section;
                }

                if ($record->field_name == 'Subsection') {
                    $record->value = EmployeeSubsection::find($record->value)->subsection;
                }

                if ($record->field_name == 'Company') {
                    $record->value = Company::find($record->value)->company;
                }

                if ($record->field_name == 'MOH Division') {
                    $record->value = MohDivision::find($record->value)->moh_division;
                }

                if ($record->field_name == 'Police Station') {
                    $record->value = Police::find($record->value)->police_station;
                }

                if ($record->field_name == 'GS Division') {
                    $record->value = GsDivision::find($record->value)->gs_division;
                }
            }
            $responseBody = $this->responseBody(true, "ApprovalController", "Approval", $result);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "ApprovalController", "Approval", $result);
        }
        return response()->json(["data" => $responseBody]);
    }







    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
