const SAVE = "save";
const UPDATE = "update";

const BANK = 'bank';
const BANK_BRANCH = 'bankBranch';

const TITLE_MAP = {
    'savebank': 'Add new Bank',
    'savebankBranch': 'Add new Bank Branch',

    'updatecountry': 'Update Country',
    'updatedistrict': 'Update District',
    'updatetown': 'Update Town',
    'updatesupplierType': 'Update Supplier Type',
    'updatesupplierStatus': 'Update Supplier Status',
    'updatebank': 'Update Bank',
    'updatebankBranch': 'Update Bank Branch',
};

const URL_MAP = {
    'bank': '/st/supplier/settings/Bank',
    'bankBranch': '/st/supplier/settings/BankBranch',
};

const URL_MAP_SEARCH = {
    'bank': '/st/supplier/settings/Bank',
    'bankBranch': '/st/supplier/settings/BankBranch',
};

// This function is use to open a modal 
function showModal(event, name) {
    var title = TITLE_MAP[event + name];
    console.log(name);


    $('#txtSettingName').attr('name', name);
    $('#settingsAddModalTitle').text(title);

    if (event == SAVE) {
        $('#btnSetting').attr('name', 'save');
        $('#btnSetting').text('Save');
        $('#txtSettingName').val('');
    }
    if (event == UPDATE) {
        $('#btnSetting').attr('name', 'update');
        $('#btnSetting').text('Update');
        var evt = $('.table tbody').on('click', '.btn', function (event) {
            var currow = $(this).closest('tr');
            var id = currow.find('td:eq(0)').attr('id');
            var value = currow.find('td:eq(1)').text();
            $('#settingID').val(id);
            $('#txtSettingName').val(value);
            if (name == TOWN) {
                var town = currow.find('td:eq(2)').text();
                var district_id = currow.find('td:eq(1)').attr('id');
                console.log(district_id);
                $('#txtSettingName').val(town);
                $('#selectDistrict').attr('value', district_id);
            }
        });
    }

    $('#settingsAddModal').modal('toggle');
}

$('#btnSetting').on('click', function (event) {
    event.preventDefault();

    var key = $('#txtSettingName').attr('name');
    console.log(key);
    var url = URL_MAP[key];
    var _token = $("input[name='_token']").val();

    var evt = event.target.name;

    if (evt == SAVE) {
        var value = $('#txtSettingName').val();

        var form = new FormData();
        form.append("_token", _token);
        form.append("value", value);
        if (key == TOWN) {
            var district_id = $('#selectDistrict').val();
            form.append("district_id", district_id);
        }
        save(url, form);
    } else if (evt == UPDATE) {
        var id = $('#settingID').val();
        update(url, id);
    }
});

// save functions of settings 
function save(url, form) {
    console.log(url);
    $.ajax({
        type: 'POST',
        url: url,
        data: form,
        processData: false,
        contentType: false,
        cache: false,
        success: function (response) {
            console.log(response);
            $('#settingsAddModal').modal('hide');
            if (response) {
                toastr.success('Record Added!');
                GetSettings(response.data.name);
            }
        }, error: function (data) {
            console.log('Something went worng!');
        }
    });

}

// Update function of settings 
function update(url, id) {
    $.ajax({
        type: 'PUT',
        url: url + '/' + id,
        data: $('#myForm').serialize(),
        success: function (response) {
            console.log(response);
            $('#settingsAddModal').modal('hide');
            GetSettings(response.data.name);
            if (response.data.success) {
                toastr.success('Record Updated!');
            }
        }, error: function (data) {
            console.log('Something went wrong!');
        }
    });
}

// Get Settings Function 
function GetSettings(key) {
    console.log(key);
    var url = URL_MAP_SEARCH[key];
    console.log(url);
    $.ajax({
        type: 'GET',
        url: url,
        processData: false,
        contentType: false,
        timeout: 800000,
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var name = response.data.name;
                var result = response.data.result;
                console.log(name);
                console.log(result);
                LoadTable(name, result);
            } else {
                toastr.error('Something went wrong');
            }
        }, error: function (data) {
            console.log('Something went wrong!');
        }
    });
}

// Load Table function 
function LoadTable(name, result) {
    var disable = { 0: "", 1: "checked" };
    var tbody = "";
    var tableName = "#tbl" + name;

    for (i = 0; i < result.length; i++) {

        var row = "<tr>";

        if (name == BANK) {
            row += '<td id="' + result[i].bank_id + '">' + GenerateId(result[i].bank_id) + '</td>';
            row += '<td>' + result[i].bank_name + '</td>';
            row += '<td class="edit edit_bank">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].bank_id + '" onclick="showModal(' + "'update'" + ',' + "'bank'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable disable_bank">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].bank_id + '" onchange="disable(event,' + "'bank'" + ')" ' + disable[result[i].status] + '>';
        } else if (name == BANK_BRANCH) {
            row += '<td id="' + result[i].bank_branch_id + '">' + GenerateId(result[i].bank_branch_id) + '</td>';
            row += '<td>' + result[i].bank_branch_name + '</td>';
            row += '<td class="edit edit_bank_branch">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].bank_branch_id + '" onclick="showModal(' + "'update'" + ',' + "'bankBranch'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable disable_bank_branch">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].bank_branch_id + '" onchange="disable(event,' + "'bankBranch'" + ')" ' + disable[result[i].status] + '>';
        }

        row += '<span class="slider round"></span>';
        row += '</label>';
        row += '</td>';
        row += '</tr>';
        tbody += row;
    }
    $(tableName).empty();
    $(tableName).append(tbody);



    if (!bank_edit_permission) {
        $('.edit_bank').hide();
    }

    if (!bank_disable_permission) {
        $('.disable_bank').hide();
    }


    if (!bank_branch_edit_permission) {
        $('.edit_bank_branch').hide();
    }

    if (!bank_branch_disable_permission) {
        $('.disable_bank_branch').hide();
    }

};

// Generate ID Function 
function GenerateId(id) {
    let pattern = {
        1: "000",
        2: "00",
        3: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}




// Disable function 
function disable(event, name) {
    var url = URL_MAP[name];
    var id = event.target.id;
    var status = event.target.checked;
    _delete(url, id, status);
}

function _delete(url, id, status) {
    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: url + '/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        success: function (response) {
            console.log(response);
            if (response.data.result == 1) {
                toastr.success('Data Activated');
            } else {
                toastr.success('Data Deactivated');
            }
        }, error: function (data) {
            console.log('Something went wrong!');
        }
    });

}