@extends('st::layouts.app')

@section('head')
<!-- DataTable -->
<link rel="stylesheet" href="{{ url('vendors/dataTable/datatables.min.css') }}" type="text/css">
<!-- Prism -->
<link rel="stylesheet" href="{{ url('vendors/prism/prism.css') }}" type="text/css">
<link rel="stylesheet" href="{{ url('assets/css/hr/employeeList.css') }}" type="text/css">


@endsection

@section('content')

<div class="row">
    <div class="col-md-12">
        <div class="card ">
            <div class="card-body">
                <h6 class="card-title">Approval list</h6>
                {{ csrf_field() }}
                <table id="tblProduct" class="table table-striped table-bordered dataTable dtr-inline collapsed" role="grid" aria-describedby="example1_info">
                    <thead>
                        <tr>
                            <th>description</th>
                            <th>view</th>
                            <th>approval</th>
                        </tr>
                    </thead>
                    <tbody id="tblProductList"></tbody>
                </table>
            </div>
        </div>
    </div>

    <!-- Approval Action Modal!-->
    <div class="modal fade" id="approvalActionModal" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="approvalActionModalTitle">Approval</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <i class="ti-close"></i>
                    </button>
                </div>
                <form method="POST" id="approvalActionForm">
                    <div class="modal-body">
                        {{csrf_field()}}
                        <div id="approvalContent">
                            <div class="table-responsive">
                                <!-- Required for Responsive -->
                                <table class="table">
                                    <thead>
                                        <tr>
                                            <th class="id">Field Name</th>
                                            <th>Value</th>
                                        </tr>
                                    </thead>
                                    <tbody id="tblData"></tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Close
                        </button>
                        <button type="button" class="btn btn-primary" id="btnApprovalAction" name="approvalAction">Approval</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

</div>
@endsection

<!-- Javascript -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
@section('script')
<!-- DataTable -->
<script src="{{ url('vendors/dataTable/datatables.min.js') }}"></script>
<script src="{{ url('assets/js/examples/datatable.js') }}"></script>
<!-- <script src="{{ url('assets/js/hr/employeeList.js') }}"></script> -->

<!-- Prism -->
<script src="{{ url('vendors/prism/prism.js') }}"></script>

<!-- custom js  -->
<!-- <script src="{{ url('assets/js/sc/product_list.js') }}"></script> -->
<script src="{{ Module::asset('st:js/approval_list.js') }}"></script>
<script src="{{ url('assets/js/notification.js') }}"></script>
@endsection