@extends('st::layouts.app')

@section('head')
<!-- Prism -->
<link rel="stylesheet" href="{{ url('vendors/prism/prism.css') }}" type="text/css">
<link href="{{ asset('assets/css/hr/settings.css') }}" media="all" rel="stylesheet" type="text/css" />
<style>
    .switch {
        position: relative;
        display: inline-block;
        width: 48px;
        height: 23px;
    }

    .switch input {
        opacity: 0;
        width: 0;
        height: 0;
    }

    .slider {
        position: absolute;
        cursor: pointer;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        background-color: #ccc;
        -webkit-transition: .4s;
        transition: .4s;
    }

    .slider:before {
        position: absolute;
        content: "";
        height: 15px;
        width: 15px;
        left: 4px;
        bottom: 4px;
        background-color: white;
        -webkit-transition: .4s;
        transition: .4s;
    }

    input:checked+.slider {
        background-color: #2196F3;
    }

    input:focus+.slider {
        box-shadow: 0 0 1px #2196F3;
    }

    input:checked+.slider:before {
        -webkit-transform: translateX(26px);
        -ms-transform: translateX(26px);
        transform: translateX(26px);
    }

    /* Rounded sliders */
    .slider.round {
        border-radius: 34px;
    }

    .slider.round:before {
        border-radius: 50%;
    }
    .edit_bank_branch{
        max-width: 80px;
    }
    .disable_bank_branch{
        max-width: 80px;
    }
    .edit_bank{
        max-width: 80px;
    }
    .disable_bank{
        max-width: 80px;
    }
</style>

<script>
    var country_edit_permission = "{{Auth::user()->can('st_supplier_setting_country_edit')}}";
    var country_disable_permission = "{{Auth::user()->can('st_supplier_setting_country_status')}}";

    var district_edit_permission = "{{Auth::user()->can('st_supplier_setting_district_edit')}}";
    var district_disable_permission = "{{Auth::user()->can('st_supplier_setting_district_status')}}";

    var town_edit_permission = "{{Auth::user()->can('st_supplier_setting_town_edit')}}";
    var town_disable_permission = "{{Auth::user()->can('st_supplier_setting_town_status')}}";

    var status_edit_permission = "{{Auth::user()->can('st_supplier_setting_supplier_status_edit')}}";
    var status_disable_permission = "{{Auth::user()->can('st_supplier_setting_supplier_status_status')}}";

    var bank_edit_permission = "{{Auth::user()->can('st_supplier_setting_bank_edit')}}";
    var bank_disable_permission = "{{Auth::user()->can('st_supplier_setting_bank_status')}}";

    var bank_branch_edit_permission = "{{Auth::user()->can('st_supplier_setting_bank_branch_edit')}}";
    var bank_branch_disable_permission = "{{Auth::user()->can('st_supplier_setting_bank_branch_status')}}";
</script>
@endsection

@section('content')

<div class="page-header">
    <div>
        <h3>Settings</h3>
        <nav aria-label="breadcrumb">
            <ol class="breadcrumb">
                <li class="breadcrumb-item">
                    <a href="#">Home</a>
                </li>
                <li class="breadcrumb-item">
                    <a href="#">Pages</a>
                </li>
                <li class="breadcrumb-item active" aria-current="page">Settings</li>
            </ol>
        </nav>
    </div>
</div>

<div class="row">
    <div class="col-md-12">
        <div class="card ">
            <div class="card-body">
                <h6 class="card-title">Settings</h6>
                <div class="accordion" id="accordionExample">

                    @if(Auth::user()->can('st_supplier_setting_bank'))
                    <div class="col-md-12 mb-3">
                        <div class="card">
                            <div class="card-header" id="headingDesignation">
                                <h5 class="mb-0">
                                    <button class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapseBank" aria-expanded="false" aria-controls="collapseDesignation" onclick="GetSettings('bank')">
                                        <i class="ti-settings mr-2"></i> Bank
                                    </button>
                                </h5>
                            </div>
                            <div id="collapseBank" class="collapse" aria-labelledby="headingDesignation" data-parent="#accordionExample">
                                <div class="card-body">
                                    <div>
                                        @if(Auth::user()->can('st_supplier_setting_bank_add'))
                                        <button type="button" class="btn btn-primary" data-target="#settingsAddModal" data-whatever="@getbootstrap" name="save" onclick="showModal('save','bank')">
                                            <i class="fa fa-plus" aria-hidden="true"></i>
                                        </button>
                                        @endif
                                    </div>
                                    <div class="table-responsive">
                                        <!-- Required for Responsive -->
                                        <table class="table table-striped table-responsive-stack">
                                            <thead>
                                                <tr>
                                                    <th class="id">ID#</th>
                                                    <th>Name</th>
                                                    <th class="edit edit_bank">Edit</th>
                                                    <th class="disable disable_bank">Status</th>
                                                </tr>
                                            </thead>
                                            <tbody id="tblbank"></tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    @endif

                    @if(Auth::user()->can('st_supplier_setting_bank_branch'))
                    <div class="col-md-12 mb-3">
                        <div class="card">
                            <div class="card-header" id="headingDesignation">
                                <h5 class="mb-0">
                                    <button class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapseBankBranch" aria-expanded="false" aria-controls="collapseDesignation" onclick="GetSettings('bankBranch')">
                                        <i class="ti-settings mr-2"></i> Bank Branch
                                    </button>
                                </h5>
                            </div>
                            <div id="collapseBankBranch" class="collapse" aria-labelledby="headingDesignation" data-parent="#accordionExample">
                                <div class="card-body">
                                    <div>
                                        @if(Auth::user()->can('st_supplier_setting_bank_branch_add'))
                                        <button type="button" class="btn btn-primary" data-target="#settingsAddModal" data-whatever="@getbootstrap" name="save" onclick="showModal('save','bankBranch')">
                                            <i class="fa fa-plus" aria-hidden="true"></i>
                                        </button>
                                        @endif
                                    </div>
                                    <div class="table-responsive">
                                        <!-- Required for Responsive -->
                                        <table class="table table-striped table-responsive-stack">
                                            <thead>
                                                <tr>
                                                    <th class="id">ID#</th>
                                                    <th>Name</th>
                                                    <th class="edit edit_bank_branch">Edit</th>
                                                    <th class="disable disable_bank_branch">Status</th>
                                                </tr>
                                            </thead>
                                            <tbody id="tblbankBranch"></tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    @endif

                </div>
            </div>
        </div>
    </div>


    <div class="modal fade" id="settingsAddModal" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="settingsAddModalTitle">Modal title</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <i class="ti-close"></i>
                    </button>
                </div>
                <form method="POST" id="myForm">
                    {{csrf_field()}}
                    <input type="hidden" id="settingID" name="settingID" value>
                    <div class="modal-body" id="settingsAddModalBody">
                        <div class="form-row">
                            <div class="col-md-12 mb-3" id="divSection">
                                <label for="txtName" id="lblDistrict">District</label>
                                <select class="form-control" id="selectDistrict" name="selectDistrict"></select>
                            </div>
                            <div class="col-md-12 mb-3">
                                <label for="txtName">Name</label>
                                <input type="text" class="form-control" id="txtSettingName" name="txtSettingName" placeholder="Name" required="">
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Close
                        </button>
                        <button type="button" class="btn btn-primary" id="btnSetting">Save</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>


@endsection

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
@section('script')
<!-- App scripts -->
<!-- <script src="{{ url('assets/js/hr/settings.js') }}"></script> -->
<!-- <script src="{{ url('assets/js/gn/settings.js') }}"></script> -->

<script src="{{ Module::asset('st:js/general_settings.js') }}"></script>

<!-- Sweet alert -->
<script src="{{ url('assets/js/examples/sweet-alert.js') }}"></script>
<!-- Prism -->
<script src="{{ url('vendors/prism/prism.js') }}"></script>
@endsection